--[[
==================================================
Dr. Mario PSP 0.3 by mikehaggar99(at)gmail(dot)com
==================================================
]]

-- load images

background = Image.load("./images/bg1.png")
optionbg = Image.load("./images/bg3.png")
presstart = Image.load("./images/ps1.png")
gameover = Image.load("./images/go1.png")
clearstage = Image.load("./images/clear1.png")
speedimage = Image.load("./images/low.png")
pauseimage = Image.load("./images/pause.png")
holdimage = Image.load("./images/hold.png")

virustiles = Image.load("./images/virus1.png")
pilltiles = Image.load("./images/pills1.png")
fonttiles = Image.load("./images/font.png")
action = Image.createEmpty(480, 272)

soundfile = Sound.load("./sounds/hit.wav")
soundfile2 = Sound.load("./sounds/gameover.wav")
soundfile3 = Sound.load("./sounds/dissolve.wav")
soundfile4 = Sound.load("./sounds/clear.wav")

red1 = { x = 0, y = 0 }
red2 = { x = 1, y = 0 }
red3 = { x = 2, y = 0 }
red4 = { x = 3, y = 0 }
red5 = { x = 4, y = 0 }
red6 = { x = 5, y = 0 }
yellow1 = { x = 0, y = 1 }
yellow2 = { x = 1, y = 1 }
yellow3 = { x = 2, y = 1 }
yellow4 = { x = 3, y = 1 }
yellow5 = { x = 4, y = 1 }
yellow6 = { x = 5, y = 1 }
blue1 = { x = 0, y = 2 }
blue2 = { x = 1, y = 2 }
blue3 = { x = 2, y = 2 }
blue4 = { x = 3, y = 2 }
blue5 = { x = 4, y = 2 }
blue6 = { x = 5, y = 2 }

-- define globals
grid = {{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},}
virus1 = {0,0,0,0}

score = 0
high = 0
level = 0
startx = 0
starty = 0
rannum = 0
ran2 = 0
speed = 0
viruses = 4
speedsum = 0

buttonPush = {0,0}
padPush = {0,0}
highscores= {0,0,0}
options = { "HORIZONTAL", 3, 6, "LOW", 0, "ON", "FEVER" }
possibleOptions =
{
	{ optiontype = 1, displayName = "SCREEN DIRECTION", values = {"HORIZONTAL","VERTICAL"}},
	{ optiontype = 2, displayName = "PAD SENSITIVITY", values = {1,10,1}},
	{ optiontype = 2, displayName = "BUTTON SENSITIVITY", values = {1,20,1}},
	{ optiontype = 1, displayName = "SPEED", values = {"LOW","MED","HI"}},
	{ optiontype = 2, displayName = "LEVEL SELECT", values = {0,20,1}},
	{ optiontype = 1, displayName = "SOUND", values = {"ON","OFF"}},
	{ optiontype = 1, displayName = "MUSIC", values = {"FEVER","CHILL","OFF"}}
}

blackColor = Color.new(0, 0, 0)
whiteColor = Color.new(255, 255, 255)
shouldExit = false
pause = false
x = 0
y = 0
go = 0
endCheck = 0
current1 = 1
pos = 0


function saveFile(filename,table)
	file = io.open(filename, "w")
	if file then
		for key, value in table do
			file:write(key .. "=" .. value .. "\n")
		end
		file:close()
	end
end


function loadFile(filename,table,index)
	file = io.open(filename, "r")
	if file then
		for line in file:lines() do
			equal = string.find(line, "=")
			if equal then
				key = tonumber(string.sub(line, 1, equal - 1))
				value = string.sub(line, equal + 1)
				if index==2 then
					value = tonumber(value)
				end
				table[key] = value
			end
		end
		file:close()
	end
end


function optionMenu()
	loadFile("option.file",options,1)
	loadFile("high.score",highscores,2)
	selectedOptionNumber = 0
	deactiveColor = Color.new(255, 255, 255)
	activeColor = Color.new(0, 255, 0)
	oldPad = Controls.read()

	while true do
		screen:clear()
		screen:blit(0, 0, optionbg)
		yay = 0
		selectedOptionValues = 0
		selectedOptionIndex = 0
		selectedOptionName = 0
		selectedOptionType = 0
		for optionKey, possibleOption in possibleOptions do
			theColor = deactiveColor
			if selectedOptionNumber == yay then
				theColor = activeColor
				selectedOptionValues = possibleOption.values
			end
			screen:print(120, yay * 34 + 25, possibleOption.displayName, theColor)
			if possibleOption.optiontype == 1 then
				for i, value in possibleOption.values do
					theColor = deactiveColor
					if options[optionKey] == value then
						theColor = activeColor
						if selectedOptionNumber == yay then
							selectedOptionIndex = i
							selectedOptionName = optionKey
							selectedOptionType = 1
						end
					end
				screen:print(i * 100 + 40, yay * 34 + 37, value, theColor)
				end
			elseif possibleOption.optiontype == 2 then
				theColor = activeColor
				if selectedOptionNumber == yay then
					selectedOptionName = optionKey
					selectedOptionIndex = options[selectedOptionName]
					selectedOptionType = 2
				end
				screen:print(140, yay * 34 + 37, string.format ("%02d",options[optionKey]), theColor)
			end
		yay = yay + 1
		end

		pad = Controls.read()
		if pad ~= oldPad then
			if pad:start() then
				screen.waitVblankStart(10)
				break
			end
			if pad:triangle() then
				screen:save("screenshot.png")
			end
			if pad:up() then
				selectedOptionNumber = selectedOptionNumber - 1
				if selectedOptionNumber < 0 then
					selectedOptionNumber = yay - 1
				end
			elseif pad:down() then
				selectedOptionNumber = selectedOptionNumber + 1
				if selectedOptionNumber >= yay then
					selectedOptionNumber = 0
				end
			end

			if selectedOptionType == 1 then
				len = table.getn(selectedOptionValues)
				if pad:left() then
					selectedOptionIndex = selectedOptionIndex - 1
					if selectedOptionIndex <= 0 then
						selectedOptionIndex = len
					end
	         options[selectedOptionName] = selectedOptionValues[selectedOptionIndex]
				elseif pad:right() then
					selectedOptionIndex = selectedOptionIndex + 1
					if selectedOptionIndex > len then
						selectedOptionIndex = 1
					end
					options[selectedOptionName] = selectedOptionValues[selectedOptionIndex]
				end
			end

			if selectedOptionType == 2 then
				if pad:left() then
					options[selectedOptionName] = options[selectedOptionName] - selectedOptionValues[3]
					if options[selectedOptionName] < selectedOptionValues[1] then
						options[selectedOptionName] = selectedOptionValues[2]
					end
				elseif pad:right() then
					options[selectedOptionName] = options[selectedOptionName] + selectedOptionValues[3]
					if options[selectedOptionName] > selectedOptionValues[2] then
						options[selectedOptionName] = selectedOptionValues[1]
					end
				end
			end
			oldPad = pad
		end
		screen.waitVblankStart()
		screen.flip()
	end

	level=tonumber(options[5])

	if options[4] == "HI" then
		speedsum=5
		speedimage = Image.load("./images/hi.png")
		high=highscores[1]
	elseif options[4] == "MED" then
		speedsum=10
		speedimage = Image.load("./images/med.png")
		high=highscores[2]
	else
		speedsum=15
		speedimage = Image.load("./images/low.png")
		high=highscores[3]
	end

	if options[1]=="VERTICAL" then
		background = Image.load("./images/bg2.png")
		gameover = Image.load("./images/go2.png")
		clearstage = Image.load("./images/clear2.png")
		virustiles = Image.load("./images/virus2.png")
		pilltiles = Image.load("./images/pills2.png")
	elseif options[1]=="HORIZONTAL" then
		background = Image.load("./images/bg1.png")
		gameover = Image.load("./images/go1.png")
		clearstage = Image.load("./images/clear1.png")
		virustiles = Image.load("./images/virus1.png")
		pilltiles = Image.load("./images/pills1.png")
	end
	saveFile("option.file",options)
end


function drawVirusTile(tile, x, y)
	if options[1]=="HORIZONTAL" then
		action:blit(192+12*x, 50+12*y, virustiles, 12*tile.x, 12*tile.y, 12, 12)
	else
		action:blit(376-20*y, 10+20*x, virustiles, 20*tile.x, 20*tile.y, 20, 20)
	end
end


function drawFontTile(tile, x, y)
	action:blit(x, y, fonttiles, 8*tile.x, 8*tile.y, 8, 8)
end


function drawPillTile(tile, x, y)
	if options[1]=="HORIZONTAL" then
		action:blit(192+12*x, 50+12*y, pilltiles, 12*tile.x, 12*tile.y, 12, 12)
	else
		action:blit(376-20*y, 10+20*x, pilltiles, 20*tile.x, 20*tile.y, 20, 20)
	end
end


function drawNextPill(tile, tile2)
	if options[1]=="HORIZONTAL" then
		action:blit(312, 52, pilltiles, 12*tile.x, 12*tile.y, 12, 12)
		action:blit(324, 52, pilltiles, 12*tile2.x, 12*tile2.y, 12, 12)
	else
		action:blit(400, 204, pilltiles, 20*tile.x, 20*tile.y, 20, 20)
		action:blit(400, 224, pilltiles, 20*tile2.x, 20*tile2.y, 20, 20)
	end
end


function drawMap()
  if x>10 then
  	if current1 == 1 then
  		current1 = 2
		else
			current1 = 1
		end
  	x=0
  end

	for i = 1, 16 do
		for j = 0, 7 do
			if grid[(i+1)][(j+1)] ~= 0 then

				if grid[(i+1)][(j+1)] == 1 then
					if current1 == 1 then
						drawVirusTile(red1, j, i)
					else
						drawVirusTile(red2, j, i)
					end
				elseif grid[(i+1)][(j+1)] == 2 then
					if current1 == 1 then
							drawVirusTile(yellow1, j, i)
					else
							drawVirusTile(yellow2, j, i)
					end
				elseif grid[(i+1)][(j+1)] == 3 then
					if current1 == 1 then
							drawVirusTile(blue1, j, i)
					else
							drawVirusTile(blue2, j, i)
					end
				elseif grid[(i+1)][(j+1)] == 4 then
					drawPillTile(red1, j, i)
				elseif grid[(i+1)][(j+1)] == 5 then
					drawPillTile(yellow1, j, i)
				elseif grid[(i+1)][(j+1)] == 6 then
					drawPillTile(blue1, j, i)
				elseif grid[(i+1)][(j+1)] == 7 then
					drawPillTile(red2, j, i)
				elseif grid[(i+1)][(j+1)] == 8 then
					drawPillTile(yellow2, j, i)
				elseif grid[(i+1)][(j+1)] == 9 then
					drawPillTile(blue2, j, i)
				elseif grid[(i+1)][(j+1)] == 10 then
					drawPillTile(red3, j, i)
				elseif grid[(i+1)][(j+1)] == 11 then
					drawPillTile(yellow3, j, i)
				elseif grid[(i+1)][(j+1)] == 12 then
					drawPillTile(blue3, j, i)
				elseif grid[(i+1)][(j+1)] == 13 then
					drawPillTile(red4, j, i)
				elseif grid[(i+1)][(j+1)] == 14 then
					drawPillTile(yellow4, j, i)
				elseif grid[(i+1)][(j+1)] == 15 then
					drawPillTile(blue4, j, i)
				elseif grid[(i+1)][(j+1)] == 16 then
					drawPillTile(red5, j, i)
				elseif grid[(i+1)][(j+1)] == 17 then
					drawPillTile(yellow5, j, i)
				elseif grid[(i+1)][(j+1)] == 18 then
					drawPillTile(blue5, j, i)
				elseif grid[(i+1)][(j+1)] == 19 then
					drawPillTile(red6, j, i)
				elseif grid[(i+1)][(j+1)] == 20 then
					drawPillTile(yellow6, j, i)
				elseif grid[(i+1)][(j+1)] == 21 then
					drawPillTile(blue6, j, i)
				end
			end
		end
	end
end

function drawNextFull()
	if ran2 == 1 then
		drawNextPill(red1, red2)
	elseif ran2 == 2 then
		drawNextPill(yellow1, yellow2)
	elseif ran2 == 3 then
		drawNextPill(blue1, blue2)
	elseif ran2 == 4 then
		drawNextPill(red1, yellow2)
	elseif ran2 == 5 then
		drawNextPill(yellow1, blue2)
	else
		drawNextPill(blue1, red2)
	end
end

function drawFullPill()
	if rannum == 1 then
		if pos == 0 then
			drawPillTile(red1, startx1, starty1)
			drawPillTile(red2, startx2, starty2)
		elseif pos == 1 then
			drawPillTile(red3, startx1, starty1)
			drawPillTile(red4, startx2, starty2)
		elseif pos == 2 then
			drawPillTile(red1, startx1, starty1)
			drawPillTile(red2, startx2, starty2)
		elseif pos == 3 then
			drawPillTile(red3, startx1, starty1)
			drawPillTile(red4, startx2, starty2)
		end
	elseif rannum == 2 then
		if pos == 0 then
			drawPillTile(yellow1, startx1, starty1)
			drawPillTile(yellow2, startx2, starty2)
		elseif pos == 1 then
			drawPillTile(yellow3, startx1, starty1)
			drawPillTile(yellow4, startx2, starty2)
		elseif pos == 2 then
			drawPillTile(yellow1, startx1, starty1)
			drawPillTile(yellow2, startx2, starty2)
		elseif pos == 3 then
			drawPillTile(yellow3, startx1, starty1)
			drawPillTile(yellow4, startx2, starty2)
		end
	elseif rannum == 3 then
		if pos == 0 then
			drawPillTile(blue1, startx1, starty1)
			drawPillTile(blue2, startx2, starty2)
		elseif pos == 1 then
			drawPillTile(blue3, startx1, starty1)
			drawPillTile(blue4, startx2, starty2)
		elseif pos == 2 then
			drawPillTile(blue1, startx1, starty1)
			drawPillTile(blue2, startx2, starty2)
		elseif pos == 3 then
			drawPillTile(blue3, startx1, starty1)
			drawPillTile(blue4, startx2, starty2)
		end
	elseif rannum == 4 then
		if pos == 0 then
			drawPillTile(red1, startx1, starty1)
			drawPillTile(yellow2, startx2, starty2)
		elseif pos == 1 then
			drawPillTile(red3, startx1, starty1)
			drawPillTile(yellow4, startx2, starty2)
		elseif pos == 2 then
			drawPillTile(yellow1, startx1, starty1)
			drawPillTile(red2, startx2, starty2)
		elseif pos == 3 then
			drawPillTile(yellow3, startx1, starty1)
			drawPillTile(red4, startx2, starty2)
		end
	elseif rannum == 5 then
		if pos == 0 then
			drawPillTile(yellow1, startx1, starty1)
			drawPillTile(blue2, startx2, starty2)
		elseif pos == 1 then
			drawPillTile(yellow3, startx1, starty1)
			drawPillTile(blue4, startx2, starty2)
		elseif pos == 2 then
			drawPillTile(blue1, startx1, starty1)
			drawPillTile(yellow2, startx2, starty2)
		elseif pos == 3 then
			drawPillTile(blue3, startx1, starty1)
			drawPillTile(yellow4, startx2, starty2)
		end
	else
		if pos == 0 then
			drawPillTile(blue1, startx1, starty1)
			drawPillTile(red2, startx2, starty2)
		elseif pos == 1 then
			drawPillTile(blue3, startx1, starty1)
			drawPillTile(red4, startx2, starty2)
		elseif pos == 2 then
			drawPillTile(red1, startx1, starty1)
			drawPillTile(blue2, startx2, starty2)
		elseif pos == 3 then
			drawPillTile(red3, startx1, starty1)
			drawPillTile(blue4, startx2, starty2)
		end
	end
end


function keyboardControl()
	screen.waitVblankStart()
	pad = Controls.read()
	if (pad:down() and options[1]=="HORIZONTAL") or (pad:left() and options[1]=="VERTICAL") then
			speed = 1
	else
			speed = speedsum
	end

	if (pad:left() and options[1]=="HORIZONTAL") or (pad:up() and options[1]=="VERTICAL") then
		if padPush[1]==0 then
			if startx1 > 0 and grid[starty1+1][startx1]==0 and grid[starty2+1][startx2]==0 then
				startx1 = startx1-1
				startx2 = startx2-1
			else
				startx1 = startx1
				startx2 = startx2
			end
		end
		padPush[1]=math.mod(padPush[1]+1,tonumber(options[2]))
		padPush[2]=0
	elseif (pad:right() and options[1]=="HORIZONTAL") or (pad:down() and options[1]=="VERTICAL") then
		if padPush[2]==0 then
			if startx2 < 7 and grid[starty1+1][startx1+2]==0 and grid[starty2+1][startx2+2]==0 then
				startx1 = startx1+1
				startx2 = startx2+1
			else
				startx1 = startx1
				startx2 = startx2
			end
		end
		padPush[2]=math.mod(padPush[2]+1,tonumber(options[2]))
		padPush[1]=0
	else
		padPush={0,0}
	end

	if pad:cross() or (pad:analogX()>96 and options[1]=="VERTICAL") or (pad:analogY()<-96 and options[1]=="VERTICAL") then
		if buttonPush[1]==0 then
			if pos == 0 and grid[starty2][startx2]==0 then
			  startx2 = startx2-1
			  starty2 = starty2-1
			  pos = 1
			elseif pos == 1 and grid[starty2+2][startx2+2]==0 then
			  startx2 = startx2+1
			  starty2 = starty2+1
			  pos = 2
			elseif pos == 2 and grid[starty2][startx2]==0 then
			  startx2 = startx2-1
			  starty2 = starty2-1
			  pos = 3
			elseif pos == 3 and grid[starty2+2][startx2+2]==0 then
			  startx2 = startx2+1
			  starty2 = starty2+1
			  pos = 0
			end
		end
		buttonPush[1]=math.mod(buttonPush[1]+1,tonumber(options[3]))
		buttonPush[2]=0
	elseif pad:circle() or (pad:analogX()<-96 and options[1]=="VERTICAL") or (pad:analogY()>96 and options[1]=="VERTICAL") then
		if buttonPush[2]==0 then
			if pos == 0 and grid[starty2][startx2]==0 then
			  startx2 = startx2-1
			  starty2 = starty2-1
			  pos = 3
			elseif pos == 1 and grid[starty2+2][startx2+2]==0 then
			  startx2 = startx2+1
			  starty2 = starty2+1
			  pos = 0
			elseif pos == 2 and grid[starty2][startx2]==0 then
			  startx2 = startx2-1
			  starty2 = starty2-1
			  pos = 1
			elseif pos == 3 and grid[starty2+2][startx2+2]==0 then
			  startx2 = startx2+1
			  starty2 = starty2+1
			  pos = 2
			end
		end
		buttonPush[2]=math.mod(buttonPush[2]+1,tonumber(options[3]))
		buttonPush[1]=0
	else
		buttonPush={0,0}
	end

	if pad:start() or pad:home() then
		action:clear()
		textv()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		text()

		if options[1]=="HORIZONTAL" then
			screen:print(222, 196, "PAUSE", whiteColor)
		else
			screen:blit(139, 71, pauseimage)
		end

		screen.waitVblankStart()
		screen.flip()
		pause = true
		stopped=0

		if Music.playing() then
			Music.pause()
		stopped=1
		end
		screen.waitVblankStart(30)
		repeat
			pad = Controls.read()
			if pad:start() then
				pause=false
				screen.waitVblankStart(30)
			end
			if pad:triangle() then
				screen:save("screenshot.png")
			end
		until pause==false
		if stopped==1 then
			Music.resume()
		end
	end
	if pad:hold() then
		action:clear()
		textv()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		text()

		if options[1]=="HORIZONTAL" then
			screen:print(225, 196, "HOLD", whiteColor)
		else
			screen:blit(139, 75, holdimage)
		end

		screen.waitVblankStart()
		screen.flip()
		pause = true
		stopped=0

		if Music.playing() then
			Music.pause()
			stopped=1
		end
		repeat
			pad = Controls.read()
			if not pad:hold() then
				pause=false
			end
			if pad:triangle() then
				screen:save("screenshot.png")
			end
		until pause==false
		if stopped==1 then
			Music.resume()
		end
	end
	if pad:select() then
		shouldExit = true
	end

	if pad:triangle() then
		screen:save("screenshot.png")
	end
end


function text()
	if options[1]=="HORIZONTAL" then
		screen:print(112, 70, string.format("%07d", high), blackColor)
		screen:print(112, 94, string.format("%07d", score), blackColor)
		screen:print(336, 150, string.format("%02d", level), blackColor)
		if speedsum==5 then
			screen:print(328, 174, string.format("%03s", " HI"), blackColor)
		elseif speedsum==10 then
			screen:print(328, 174, string.format("%03s", "MED"), blackColor)
		else
			screen:print(328, 174, string.format("%03s", "LOW"), blackColor)
		end
		screen:print(336, 198, string.format("%02d", viruses), blackColor)
	end
end


function textv()
	if high > 9999999 then
		high = 9999999
	end
	if score > 9999999 then
		score = 9999999
	end

	if options[1]=="VERTICAL" then
		j=0
		for i=1,string.len(high) do
			letter=string.sub(high, i, i)
			if string.len(high) == 1 and i==1 then
				j = 7
			elseif string.len(high) == 3 and i==1 then
				j = 5
			elseif string.len(high) == 4 and i==1 then
				j = 4
			elseif string.len(high) == 5 and i==1 then
				j = 3
			elseif string.len(high) == 6 and i==1 then
				j = 2
			else
				j=j+1
			end

			if letter=="0" then
				drawFontTile(red1, 289, 188+(8*j))
			elseif letter=="1" then
				drawFontTile(red2, 289, 188+(8*j))
			elseif letter=="2" then
				drawFontTile(red3, 289, 188+(8*j))
			elseif letter=="3" then
				drawFontTile(red4, 289, 188+(8*j))
			elseif letter=="4" then
				drawFontTile(red5, 289, 188+(8*j))
			elseif letter=="5" then
				drawFontTile(yellow1, 289, 188+(8*j))
			elseif letter=="6" then
				drawFontTile(yellow2, 289, 188+(8*j))
			elseif letter=="7" then
				drawFontTile(yellow3, 289, 188+(8*j))
			elseif letter=="8" then
				drawFontTile(yellow4, 289, 188+(8*j))
			else
				drawFontTile(yellow5, 289, 188+(8*j))
			end
		end

		j=0
		for i=1,string.len(score) do
			letter=string.sub(score, i, i)
			if string.len(score) == 1 and i==1 then
				j = 7
			elseif string.len(score) == 3 and i==1 then
				j = 5
			elseif string.len(score) == 4 and i==1 then
				j = 4
			elseif string.len(score) == 5 and i==1 then
				j = 3
			elseif string.len(score) == 6 and i==1 then
				j = 2
			else
				j=j+1
			end

			if letter=="0" then
				drawFontTile(red1, 265, 188+(8*j))
			elseif letter=="1" then
				drawFontTile(red2, 265, 188+(8*j))
			elseif letter=="2" then
				drawFontTile(red3, 265, 188+(8*j))
			elseif letter=="3" then
				drawFontTile(red4, 265, 188+(8*j))
			elseif letter=="4" then
				drawFontTile(red5, 265, 188+(8*j))
			elseif letter=="5" then
				drawFontTile(yellow1, 265, 188+(8*j))
			elseif letter=="6" then
				drawFontTile(yellow2, 265, 188+(8*j))
			elseif letter=="7" then
				drawFontTile(yellow3, 265, 188+(8*j))
			elseif letter=="8" then
				drawFontTile(yellow4, 265, 188+(8*j))
			else
				drawFontTile(yellow5, 265, 188+(8*j))
			end
		end

		j=0
		for i=1,string.len(level) do
			letter=string.sub(level, i, i)
			if string.len(level) == 1 and i==1 then
				j = 2
			else
				j=j+1
			end

			if letter=="0" then
				drawFontTile(red1, 192, 212+(8*j))
			elseif letter=="1" then
				drawFontTile(red2, 192, 212+(8*j))
			elseif letter=="2" then
				drawFontTile(red3, 192, 212+(8*j))
			elseif letter=="3" then
				drawFontTile(red4, 192, 212+(8*j))
			elseif letter=="4" then
				drawFontTile(red5, 192, 212+(8*j))
			elseif letter=="5" then
				drawFontTile(yellow1, 192, 212+(8*j))
			elseif letter=="6" then
				drawFontTile(yellow2, 192, 212+(8*j))
			elseif letter=="7" then
				drawFontTile(yellow3, 192, 212+(8*j))
			elseif letter=="8" then
				drawFontTile(yellow4, 192, 212+(8*j))
			else
				drawFontTile(yellow5, 192, 212+(8*j))
			end
		end

		j=0
		for i=1,string.len(viruses) do
			letter=string.sub(viruses, i, i)
			if string.len(viruses) == 1 and i==1 then
				j = 2
			else
				j=j+1
			end

			if letter=="0" then
				drawFontTile(red1, 144, 212+(8*j))
			elseif letter=="1" then
				drawFontTile(red2, 144, 212+(8*j))
			elseif letter=="2" then
				drawFontTile(red3, 144, 212+(8*j))
			elseif letter=="3" then
				drawFontTile(red4, 144, 212+(8*j))
			elseif letter=="4" then
				drawFontTile(red5, 144, 212+(8*j))
			elseif letter=="5" then
				drawFontTile(yellow1, 144, 212+(8*j))
			elseif letter=="6" then
				drawFontTile(yellow2, 144, 212+(8*j))
			elseif letter=="7" then
				drawFontTile(yellow3, 144, 212+(8*j))
			elseif letter=="8" then
				drawFontTile(yellow4, 144, 212+(8*j))
			else
				drawFontTile(yellow5, 144, 212+(8*j))
			end
		end

		action:blit(168, 212, speedimage)
	end
end


function pillfall()
	for i=-4,0 do
		starty1 = i
		starty2 = i
		action:clear()
		drawMap()
		drawFullPill()
		drawNextFull()
		textv()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		text()
		x=x+1
		screen.waitVblankStart(4)
		screen.flip()
	end
	x=x+1
	screen.waitVblankStart(4)

	starty1 = 1
	starty2 = 1
end


function put()
	if starty2>0 then
		if rannum == 1 then
			if pos == 0 then
				grid[starty1+1][startx1+1] = 4
				grid[starty2+1][startx2+1] = 7
			elseif pos == 1 then
				grid[starty1+1][startx1+1] = 10
				grid[starty2+1][startx2+1] = 13
			elseif pos == 2 then
				grid[starty1+1][startx1+1] = 4
				grid[starty2+1][startx2+1] = 7
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 10
				grid[starty2+1][startx2+1] = 13
			end
		elseif rannum == 2 then
			if pos == 0 then
				grid[starty1+1][startx1+1] = 5
				grid[starty2+1][startx2+1] = 8
			elseif pos == 1 then
				grid[starty1+1][startx1+1] = 11
				grid[starty2+1][startx2+1] = 14
			elseif pos == 2 then
				grid[starty1+1][startx1+1] = 5
				grid[starty2+1][startx2+1] = 8
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 11
				grid[starty2+1][startx2+1] = 14
			end
		elseif rannum == 3 then
			if pos == 0 then
				grid[starty1+1][startx1+1] = 6
				grid[starty2+1][startx2+1] = 9
			elseif pos == 1 then
				grid[starty1+1][startx1+1] = 12
				grid[starty2+1][startx2+1] = 15
			elseif pos == 2 then
				grid[starty1+1][startx1+1] = 6
				grid[starty2+1][startx2+1] = 9
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 12
				grid[starty2+1][startx2+1] = 15
			end
		elseif rannum == 4 then
			if pos == 0 then
				grid[starty1+1][startx1+1] = 4
				grid[starty2+1][startx2+1] = 8
			elseif pos == 1 then
				grid[starty1+1][startx1+1] = 10
				grid[starty2+1][startx2+1] = 14
			elseif pos == 2 then
				grid[starty1+1][startx1+1] = 5
				grid[starty2+1][startx2+1] = 7
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 11
				grid[starty2+1][startx2+1] = 13
			end
		elseif rannum == 5 then
			if pos == 0 then
				grid[starty1+1][startx1+1] = 5
				grid[starty2+1][startx2+1] = 9
			elseif pos == 1 then
				grid[starty1+1][startx1+1] = 11
				grid[starty2+1][startx2+1] = 15
			elseif pos == 2 then
				grid[starty1+1][startx1+1] = 6
				grid[starty2+1][startx2+1] = 8
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 12
				grid[starty2+1][startx2+1] = 14
			end
		else
			if pos == 0 then
				grid[starty1+1][startx1+1] = 6
				grid[starty2+1][startx2+1] = 7
			elseif pos == 1 then
				grid[starty1+1][startx1+1] = 12
				grid[starty2+1][startx2+1] = 13
			elseif pos == 2 then
				grid[starty1+1][startx1+1] = 4
				grid[starty2+1][startx2+1] = 9
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 10
				grid[starty2+1][startx2+1] = 15
			end
		end
	else
		if rannum == 1 then
			grid[starty1+1][startx1+1] = 16
		elseif rannum == 2 then
			grid[starty1+1][startx1+1] = 17
		elseif rannum == 3 then
			grid[starty1+1][startx1+1] = 18
		elseif rannum == 4 then
			if pos == 1 then
				grid[starty1+1][startx1+1] = 16
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 17
			end
		elseif rannum == 5 then
			if pos == 1 then
				grid[starty1+1][startx1+1] = 17
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 18
			end
		else
			if pos == 1 then
				grid[starty1+1][startx1+1] = 18
			elseif pos == 3 then
				grid[starty1+1][startx1+1] = 16
			end
		end
	end

	action:clear()
	drawMap()
	drawNextFull()
	textv()
	screen:blit(0, 0, background)
	screen:blit(0, 0, action)
	text()
	screen.waitVblankStart()
	screen.flip()
	if options[6]=="ON" then
		soundfile:play()
	end
	x=x+1
	screen.waitVblankStart(2)


	repeat

		power=0

		virus1 = {0,0,0,0}

		for i = 1, 16 do
			for j = 0, 4 do
				for k = 0, 3 do

					if grid[(i+1)][(j+k+1)] ~= 0 then
						if math.mod(grid[(i+1)][(j+k+1)],3) == 1 then
							virus1[k+1] = 19
						elseif math.mod(grid[(i+1)][(j+k+1)],3) == 2 then
							virus1[k+1] = 20
						elseif math.mod(grid[(i+1)][(j+k+1)],3) == 0 then
							virus1[k+1] = 21
						end
					end
				end
				if virus1[1]==virus1[2] and virus1[2]==virus1[3] and virus1[3]==virus1[4] and virus1[1] ~=0 then

					for k = 0, 3 do
						if grid[(i+1)][(j+k+1)] == 1 or grid[(i+1)][(j+k+1)] == 2 or grid[(i+1)][(j+k+1)] == 3 then
							viruses = viruses-1
							score = score+100
							if high < score then
								high = score
							end
						end

						if (grid[(i+1)][(j+k+1)]==4 or grid[(i+1)][(j+k+1)]==5 or grid[(i+1)][(j+k+1)]==6) and grid[(i+1)][(j+k+2)]~=0 then
							if math.mod(grid[(i+1)][(j+k+2)],3)==1 then
								grid[(i+1)][(j+k+2)]=16
							elseif math.mod(grid[(i+1)][(j+k+2)],3)==2 then
								grid[(i+1)][(j+k+2)]=17
							elseif math.mod(grid[(i+1)][(j+k+2)],3)==0 then
								grid[(i+1)][(j+k+2)]=18
							end
						elseif (grid[(i+1)][(j+k+1)]==7 or grid[(i+1)][(j+k+1)]==8 or grid[(i+1)][(j+k+1)]==9) and grid[(i+1)][(j+k)]~=0 then
							if math.mod(grid[(i+1)][(j+k)],3)==1 then
								grid[(i+1)][(j+k)]=16
							elseif math.mod(grid[(i+1)][(j+k)],3)==2 then
								grid[(i+1)][(j+k)]=17
							elseif math.mod(grid[(i+1)][(j+k)],3)==0 then
								grid[(i+1)][(j+k)]=18
							end
						elseif (grid[(i+1)][(j+k+1)]==10 or grid[(i+1)][(j+k+1)]==11 or grid[(i+1)][(j+k+1)]==12) and grid[(i)][(j+k+1)]~=0 then
							if math.mod(grid[(i)][(j+k+1)],3)==1 then
								grid[(i)][(j+k+1)]=16
							elseif math.mod(grid[(i)][(j+k+1)],3)==2 then
								grid[(i)][(j+k+1)]=17
							elseif math.mod(grid[(i)][(j+k+1)],3)==0 then
								grid[(i)][(j+k+1)]=18
							end
						elseif (grid[(i+1)][(j+k+1)]==13 or grid[(i+1)][(j+k+1)]==14 or grid[(i+1)][(j+k+1)]==15) and grid[(i+2)][(j+k+1)]~=0 then
							if math.mod(grid[(i+2)][(j+k+1)],3)==1 then
								grid[(i+2)][(j+k+1)]=16
							elseif math.mod(grid[(i+2)][(j+k+1)],3)==2 then
								grid[(i+2)][(j+k+1)]=17
							elseif math.mod(grid[(i+2)][(j+k+1)],3)==0 then
								grid[(i+2)][(j+k+1)]=18
							end
						end
					end
					grid[(i+1)][(j+1)]=virus1[1]
					grid[(i+1)][(j+2)]=virus1[1]
					grid[(i+1)][(j+3)]=virus1[1]
					grid[(i+1)][(j+4)]=virus1[1]
					power=1
				end
				virus1 = {0,0,0,0}
			end
		end

		virus1 = {0,0,0,0}

		for i = 0, 7 do
			for j = 1, 13 do
				for k = 0, 3 do

					if grid[(j+k+1)][(i+1)] ~= 0 then
						if math.mod(grid[(j+k+1)][(i+1)],3) == 1 then
							virus1[k+1] = 19
						elseif math.mod(grid[(j+k+1)][(i+1)],3) == 2 then
							virus1[k+1] = 20
						elseif math.mod(grid[(j+k+1)][(i+1)],3) == 0 then
							virus1[k+1] = 21
						end
					end
				end
				if virus1[1]==virus1[2] and virus1[2]==virus1[3] and virus1[3]==virus1[4] and virus1[1] ~=0 then

					for k = 0, 3 do
						if grid[(j+k+1)][(i+1)] == 1 or grid[(j+k+1)][(i+1)] == 2 or grid[(j+k+1)][(i+1)] == 3 then
							viruses = viruses-1
							score = score+100
							if high < score then
								high = score
							end
						end
						if (grid[(j+k+1)][(i+1)]==4 or grid[(j+k+1)][(i+1)]==5 or grid[(j+k+1)][(i+1)]==6) and grid[(j+k+1)][(i+2)]~=0 then
							if math.mod(grid[(j+k+1)][(i+2)],3)==1 then
								grid[(j+k+1)][(i+2)]=16
							elseif math.mod(grid[(j+k+1)][(i+2)],3)==2 then
								grid[(j+k+1)][(i+2)]=17
							elseif math.mod(grid[(j+k+1)][(i+2)],3)==0 then
								grid[(j+k+1)][(i+2)]=18
							end
						elseif (grid[(j+k+1)][(i+1)]==7 or grid[(j+k+1)][(i+1)]==8 or grid[(j+k+1)][(i+1)]==9) and grid[(j+k+1)][(i)]~=0 then
							if math.mod(grid[(j+k+1)][(i)],3)==1 then
								grid[(j+k+1)][(i)]=16
							elseif math.mod(grid[(j+k+1)][(i)],3)==2 then
								grid[(j+k+1)][(i)]=17
							elseif math.mod(grid[(j+k+1)][(i)],3)==0 then
								grid[(j+k+1)][(i)]=18
							end
						elseif (grid[(j+k+1)][(i+1)]==10 or grid[(j+k+1)][(i+1)]==11 or grid[(j+k+1)][(i+1)]==12) and grid[(j+k)][(i+1)]~=0 then
							if math.mod(grid[(j+k)][(i+1)],3)==1 then
								grid[(j+k)][(i+1)]=16
							elseif math.mod(grid[(j+k)][(i+1)],3)==2 then
								grid[(j+k)][(i+1)]=17
							elseif math.mod(grid[(j+k)][(i+1)],3)==0 then
								grid[(j+k)][(i+1)]=18
							end
						elseif (grid[(j+k+1)][(i+1)]==13 or grid[(j+k+1)][(i+1)]==14 or grid[(j+k+1)][(i+1)]==15) and grid[(j+k+2)][(i+1)]~=0 then
							if math.mod(grid[(j+k+2)][(i+1)],3)==1 then
								grid[(j+k+2)][(i+1)]=16
							elseif math.mod(grid[(j+k+2)][(i+1)],3)==2 then
								grid[(j+k+2)][(i+1)]=17
							elseif math.mod(grid[(j+k+2)][(i+1)],3)==0 then
								grid[(j+k+2)][(i+1)]=18
							end
						end
					end

					grid[(j+1)][(i+1)]=virus1[1]
					grid[(j+2)][(i+1)]=virus1[1]
					grid[(j+3)][(i+1)]=virus1[1]
					grid[(j+4)][(i+1)]=virus1[1]
					power=1
				end
				virus1 = {0,0,0,0}
			end
		end

		if power==1 then
			action:clear()
			drawMap()
			drawNextFull()
			textv()
			screen:blit(0, 0, background)
			screen:blit(0, 0, action)
			text()
			screen.waitVblankStart()
			screen.flip()
			if options[6]=="ON" then
				soundfile3:play()
			end
			x=x+1
			screen.waitVblankStart(10)

			for i = 1, 16 do
				for j = 0, 7 do
					if grid[(i+1)][(j+1)] == 19 or grid[(i+1)][(j+1)] == 20 or grid[(i+1)][(j+1)] == 21 then
						grid[(i+1)][(j+1)] = 0
					end
				end
			end

			action:clear()
			drawMap()
			drawNextFull()
			textv()
			screen:blit(0, 0, background)
			screen:blit(0, 0, action)
			text()
			screen.waitVblankStart()
			screen.flip()
			x=x+1
			screen.waitVblankStart(10)

			check=1
			repeat
				check=0
				i = 15
				repeat
					for j = 0, 7 do
						if grid[(i+2)][(j+1)]==0 then
							if (grid[(i+1)][(j+1)]) > 3 and (grid[(i+1)][(j+1)]) < 7 and grid[(i+2)][(j+2)]==0 then
								grid[(i+2)][(j+1)]=grid[(i+1)][(j+1)]
								grid[(i+2)][(j+2)]=grid[(i+1)][(j+2)]
								grid[(i+1)][(j+1)]=0
								grid[(i+1)][(j+2)]=0
								check = 1
							elseif (grid[(i+1)][(j+1)]) > 9 and (grid[(i+1)][(j+1)]) < 13 then
								grid[(i+2)][(j+1)]=grid[(i+1)][(j+1)]
								grid[(i+1)][(j+1)]=grid[(i)][(j+1)]
								grid[(i)][(j+1)]=0
								check = 1
							elseif (grid[(i+1)][(j+1)]) > 15 and (grid[(i+1)][(j+1)]) < 19 then
								grid[(i+2)][(j+1)]=grid[(i+1)][(j+1)]
								grid[(i+1)][(j+1)]=0
								check = 1
							end
						end
					end
					i=i-1
				until i==0
				if check == 1 then
					action:clear()
					drawMap()
					drawNextFull()
					textv()
					screen:blit(0, 0, background)
					screen:blit(0, 0, action)
					text()
					screen.waitVblankStart()
					screen.flip()
					if options[6]=="ON" then
						soundfile:play()
					end
					x=x+1
					screen.waitVblankStart(5)
				end
			until check==0
		end

	until power==0


	if grid[2][4]~=0 or grid[2][5]~=0 then
		go = 1
	end

	startx1 = 3
	starty1 = 1
	startx2 = 4
	starty2 = 1
	speed = speedsum

	pos=0
	rancheck = 0

	if rannum == ran2 then
		rancheck = ran2
	end

	rannum = ran2

	repeat
		ran2=math.random(1,9)
		if ran2 == 7 then
			ran2 = 4
		elseif ran2 == 8 then
			ran2 = 5
		elseif ran2 == 9 then
			ran2 = 6
		end
	until rancheck~=ran2

	if viruses > 0 then
		pillfall()
	end
end

function checkEnd()
	if starty1==17 then
		starty1=starty1-1
		starty2=starty2-1
		put()
		y = 0
	elseif grid[(starty1+1)][(startx1+1)] >= 1 then
		starty1=starty1-1
		starty2=starty2-1
		put()
		y = 0
	elseif grid[(starty2+1)][(startx2+1)] >= 1 then
		starty1=starty1-1
		starty2=starty2-1
		put()
		y = 0
	end
end


function startMenu()
	screen:blit(0, 0, presstart)
	screen.waitVblankStart()
	screen.flip()
	gostart=false
	repeat
		pad = Controls.read()
		if pad:start() then
			presstart:clear()
			gostart=true
		end

		if pad:triangle() then
			screen:save("screenshot.png")
		end
	until gostart==true
end


function newGame(type)
	action:clear()
	if type == 0 then
		score = 0
	end
	startx1 = 3
	starty1 = 1
	startx2 = 4
	starty2 = 1
	endCheck = 0
	go = 0
	speed = speedsum
	grid = {{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},}

	viruses = 0
	ran3=math.random(1,3)
	repeat
		if level < 10 then
			ran1=math.random(8,17)
		else
			ran1=math.random(5,17)
		end
		ran2=math.random(1,8)
		ran3=math.mod(ran3+1,3)
		if ran3 == 0 then
			ran3=3
		end

		if grid[(ran1)][(ran2)] == 0 then
			if (grid[(ran1)][(ran2+1)]~=ran3 or grid[(ran1)][(ran2+2)]~=ran3) and (grid[(ran1)][(ran2-1)]~=ran3 or grid[(ran1)][(ran2-2)]~=ran3) and (grid[(ran1)][(ran2-1)]~=ran3 or grid[(ran1)][(ran2+1)]~=ran3) and (grid[(ran1+1)][(ran2)]~=ran3 or grid[(ran1+2)][(ran2)]~=ran3) and (grid[(ran1-1)][(ran2)]~=ran3 or grid[(ran1-2)][(ran2)]~=ran3) and (grid[(ran1-1)][(ran2)]~=ran3 or grid[(ran1+1)][(ran2)]~=ran3) then
				viruses=viruses+1
				grid[(ran1)][(ran2)] = ran3
			else
				ran3=ran3-1
			end
		else
			ran3=ran3-1
		end
	until viruses==(4*(level+1))

	if options[7]~="OFF" then
		Music.playFile("./sounds/"..options[7]..".it", true)
	end

	pos = 0

	rannum=math.random(1,9)
	if rannum == 7 then
		rannum = 4
	elseif rannum == 8 then
		rannum = 5
	elseif rannum == 9 then
		rannum = 6
	end

	ran2=math.random(1,9)
	if ran2 == 7 then
		ran2 = 4
	elseif ran2 == 8 then
		ran2 = 5
	elseif ran2 == 9 then
		ran2 = 6
	end
	pillfall()
end


-- init
math.randomseed(os.time())
startMenu()
optionMenu()

newGame(0)

-- game loop

while true do

	keyboardControl()

	if y >= speed then
		if starty1<17 then
			starty1=starty1+1
			starty2=starty2+1
		else
			starty1=starty1
			starty2=starty2
		end
		y = 0
	end

	action:clear()
	drawMap()

	drawFullPill()
	drawNextFull()

	checkEnd()

	textv()

	screen:blit(0, 0, background)
	screen:blit(0, 0, action)

	text()

  x = x+1
  y = y+1

	screen.waitVblankStart()
	screen.flip()

	if viruses == 0 then
		textv()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		text()

		if options[1]=="HORIZONTAL" then
			screen:blit(212, 80, clearstage)
			screen:print(222, 216, "PRESS", whiteColor)
			screen:print(222, 224, "START", whiteColor)
		else
			screen:blit(139, 62, clearstage)
		end

		screen.waitVblankStart()
		screen.flip()
		if Music.playing() then
			Music.stop()
		end
		if options[6]=="ON" then
			soundfile4:play()
		end
		gostart=false
		repeat
			pad = Controls.read()
			if pad:start() then
				gostart=true
			end
			if pad:triangle() then
				screen:save("screenshot.png")
			end
		until gostart==true
		level = level + 1
		if level > 20 then
			level = 0
		end
		newGame(1)
	end
	if go == 1 then
		action:clear()
		drawMap()
		drawFullPill()
		drawNextFull()
		textv()
		screen:blit(0, 0, background)
		screen:blit(0, 0, action)
		text()
		if options[1]=="HORIZONTAL" then
			screen:blit(212, 88, gameover)
			screen:print(222, 216, "PRESS", whiteColor)
			screen:print(222, 224, "START", whiteColor)
		else
			screen:blit(139, 62, gameover)
		end

		screen.waitVblankStart()
		screen.flip()
		highscores[speedsum/5]=high
		saveFile("high.score",highscores)

		if Music.playing() then
			Music.stop()
		end
		if options[6]=="ON" then
			soundfile2:play()
		end
		gostart=false
		repeat
			pad = Controls.read()
			if pad:start() then
				gostart=true
			end
			if pad:triangle() then
				screen:save("screenshot.png")
			end
		until gostart==true
		optionMenu()
		newGame(0)
	end
	if(shouldExit) then
		if Music.playing() then
			Music.stop()
		end
		highscores[speedsum/5]=high
		saveFile("high.score",highscores)
		break
	end
end
